<?php
namespace Bar\Foobar\Domain\Model;


/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2014
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Foobarbazza
 */
class Foobarbazza extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * foo
	 *
	 * @var string
	 */
	protected $foo = '';

	/**
	 * bar
	 *
	 * @var string
	 */
	protected $bar = '';

	/**
	 * baz
	 *
	 * @var string
	 */
	protected $baz = '';

	/**
	 * Returns the foo
	 *
	 * @return string $foo
	 */
	public function getFoo() {
		return $this->foo;
	}

	/**
	 * Sets the foo
	 *
	 * @param string $foo
	 * @return void
	 */
	public function setFoo($foo) {
		$this->foo = $foo;
	}

	/**
	 * Returns the bar
	 *
	 * @return string $bar
	 */
	public function getBar() {
		return $this->bar;
	}

	/**
	 * Sets the bar
	 *
	 * @param string $bar
	 * @return void
	 */
	public function setBar($bar) {
		$this->bar = $bar;
	}

	/**
	 * Returns the baz
	 *
	 * @return string $baz
	 */
	public function getBaz() {
		return $this->baz;
	}

	/**
	 * Sets the baz
	 *
	 * @param string $baz
	 * @return void
	 */
	public function setBaz($baz) {
		$this->baz = $baz;
	}

}