<?php

namespace Bar\Foobar\Tests\Unit\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test case for class \Bar\Foobar\Domain\Model\Foobarbazza.
 *
 * @copyright Copyright belongs to the respective authors
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class FoobarbazzaTest extends \TYPO3\CMS\Core\Tests\UnitTestCase {
	/**
	 * @var \Bar\Foobar\Domain\Model\Foobarbazza
	 */
	protected $subject = NULL;

	protected function setUp() {
		$this->subject = new \Bar\Foobar\Domain\Model\Foobarbazza();
	}

	protected function tearDown() {
		unset($this->subject);
	}

	/**
	 * @test
	 */
	public function getFooReturnsInitialValueForString() {
		$this->assertSame(
			'',
			$this->subject->getFoo()
		);
	}

	/**
	 * @test
	 */
	public function setFooForStringSetsFoo() {
		$this->subject->setFoo('Conceived at T3CON10');

		$this->assertAttributeEquals(
			'Conceived at T3CON10',
			'foo',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getBarReturnsInitialValueForString() {
		$this->assertSame(
			'',
			$this->subject->getBar()
		);
	}

	/**
	 * @test
	 */
	public function setBarForStringSetsBar() {
		$this->subject->setBar('Conceived at T3CON10');

		$this->assertAttributeEquals(
			'Conceived at T3CON10',
			'bar',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getBazReturnsInitialValueForString() {
		$this->assertSame(
			'',
			$this->subject->getBaz()
		);
	}

	/**
	 * @test
	 */
	public function setBazForStringSetsBaz() {
		$this->subject->setBaz('Conceived at T3CON10');

		$this->assertAttributeEquals(
			'Conceived at T3CON10',
			'baz',
			$this->subject
		);
	}
}
